/**
  *  \file client/chart/drawmarkermode.h
  *  \brief Starchart Mode: WDrawMarkerChartMode
  *
  *  (c) 2001-2018 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_CHART_DRAWMARKERMODE_H
#define PCC_V2_CLIENT_CHART_DRAWMARKERMODE_H

#include "client/chart/markermode.h"

/** Chart mode for drawing a line or rectangle. Moves the second end
    of the object around. */
class WDrawMarkerChartMode : public WMarkerChartMode {
    void finishDrawing();
 public:
    WDrawMarkerChartMode(GDrawingContainer::iterator p);
    ~WDrawMarkerChartMode();

    void onMove(GChartLocation& loc);
    void drawOverlays(GfxCanvas& can, GChartLocation& loc);
    bool handleEvent(const UIEvent& event, GChartLocation& loc);
};

#endif
