/**
  *  \file client/tiles/taskmsgtile.h
  *  \brief Class WTaskMessageTile
  *
  *  (c) 2001-2018 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_TILES_TASKMSGTILE_H
#define PCC_V2_CLIENT_TILES_TASKMSGTILE_H

#include <memory>
#include "client/wtile.h"
#include "cpluslib/sigslot.h"
#include "ui/widgets/button.h"

class WAutoTaskObjectSelection;

/** Base class for task command tiles.
    Task command tiles can display a notitifcation message. */
class WTaskMessageTile : public WTile {
 public:
    WTaskMessageTile(GfxPoint pt);

    void initTask(WAutoTaskObjectSelection* atsel, int buttonWidth);
    void updateTask();
    bool drawTask(GfxCanvas& can);
    void onConfirm();

 private:
    std::auto_ptr<UIButton> btn_confirm;
    WAutoTaskObjectSelection* atsel;
    SignalConnection conn_task_changed;
    int buttonWidth;
};

#endif
