/**
  *  \file client/wcomplist.h
  *
  *  (c) 2001-2018 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WCOMPLIST_H
#define PCC_V2_CLIENT_WCOMPLIST_H

#include <vector>
#include "game/struct.h"        // TTechLevel
#include "ui/listbox.h"

class GPlanet;
class GComponent;

class WComponentListbox : public UIListbox {
 protected:
    GPlanet*   tick_planet;
 public:
    WComponentListbox(int id, int lines, int width, GPlanet* planet);

 protected:
    void drawComponent(GfxContext& ctx, GfxRect& area, const GComponent& com, TTechLevel tech_area, int have);
};

class WHullListbox : public WComponentListbox {
    std::vector<int>  content;
 public:
    WHullListbox(int id, int lines, int width, GPlanet* planet);
    ~WHullListbox();

    void drawPart(GfxCanvas& can, int from, int to);

    int   getCurrentHull() const;
    void  addHullId(int n);
    void  swapContents(std::vector<int>& new_content);
    void  scrollToHull(int n);
};

class WEngineListbox : public WComponentListbox {
 public:
    WEngineListbox(int id, int width, GPlanet* tick_planet);
    void drawPart(GfxCanvas& can, int from, int to);
};

class WBeamListbox : public WComponentListbox {
 public:
    WBeamListbox(int id, int width, GPlanet* tick_planet);
    void drawPart(GfxCanvas& can, int from, int to);
};

class WLauncherListbox : public WComponentListbox {
 public:
    WLauncherListbox(int id, int width, GPlanet* tick_planet);
    void drawPart(GfxCanvas& can, int from, int to);
};

#endif
