/**
  *  \file client/widgets/partcount.h
  *  \brief Ship Build Screen Part Count Selection/Display
  *
  *  (c) 2001-2018 Stefan Reuther <Streu@gmx.de>
  *
  *  This program is free software; you can redistribute it and/or
  *  modify it under the terms of file `COPYING' that comes with the
  *  source code.
  *
  *  This program is distributed in the hope that it will be useful,
  *  but WITHOUT ANY WARRANTY; without even the implied warranty of
  *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
  */
#ifndef PCC_V2_CLIENT_WIDGETS_PARTCOUNT_H
#define PCC_V2_CLIENT_WIDGETS_PARTCOUNT_H

#include "ui/ui.h"
#include "ui/widgets/button.h"

class WPartCountInfo : public UIWidget {
    const bool torps;
    int want, max;
 public:
    WPartCountInfo(bool torps);
    void drawContent(GfxCanvas& can);
    void getLayoutInfo(LayoutInfo& info);
    void setPartsMax(int n);
    void setPartsWanted(int n);
    int getPartsWanted() const
        { return want; }
    int getPartsMax() const
        { return max; }
};

class WPartCountGroup : public UIGroup {
    WPartCountInfo pci;
    UIGroup button_group;
    UIButton plus, minus;

    void init();
    void onAdd(int prefix);
    void onRemove(int prefix);
 public:
    WPartCountGroup(bool torps);
    ~WPartCountGroup();

    void setPartsMax(int n);
    void setPartsWanted(int n)
        { pci.setPartsWanted(n); }
    int getPartsWanted() const
        { return pci.getPartsWanted(); }
    int getPartsMax() const
        { return pci.getPartsMax(); }

    Signal0 sig_count_changed;
};

#endif
